Open CASCADE Technology: gp_Circ2d Class Reference

Open CASCADE Technology 6.8.0

- Main Page
- Related Pages
- Namespaces
- Data Structures
- Files

- Data Structures
- Data Structure Index
- Class Hierarchy
- Data Fields

Public Member Functions
gp_Circ2d Class Reference

Describes a circle in the plane (2D space). A circle is defined by its radius and positioned in the plane with a coordinate system (a gp_Ax22d object) as follows: More...

`#include <gp_Circ2d.hxx>`

## Public Member Functions
| gp_Circ2d ()
| creates an indefinite circle. More...
| gp_Circ2d (const gp_Ax2d &XAxis, const Standard_Real Radius, const Standard_Boolean Sense=Standard_True)
| The location point of XAxis is the center of the circle. Warnings : It is not forbidden to create a circle with Radius = 0.0 Raises ConstructionError if Radius < 0.0. Raised if Radius < 0.0. More...
| gp_Circ2d (const gp_Ax22d &Axis, const Standard_Real Radius)
| Axis defines the Xaxis and Yaxis of the circle which defines the origin and the sense of parametrization. The location point of Axis is the center of the circle. Warnings : It is not forbidden to create a circle with Radius = 0.0 Raises ConstructionError if Radius < 0.0. Raised if Radius < 0.0. More...
void | SetLocation (const gp_Pnt2d &P)
| Changes the location point (center) of the circle. More...
void | SetXAxis (const gp_Ax2d &A)
| Changes the X axis of the circle. More...
void | SetAxis (const gp_Ax22d &A)
| Changes the X axis of the circle. More...
void | SetYAxis (const gp_Ax2d &A)
| Changes the Y axis of the circle. More...
void | SetRadius (const Standard_Real Radius)
| Modifies the radius of this circle. This class does not prevent the creation of a circle where Radius is null. Exceptions Standard_ConstructionError if Radius is negative. More...
Standard_Real | Area () const
| Computes the area of the circle. More...
void | Coefficients (Standard_Real &A, Standard_Real &B, Standard_Real &C, Standard_Real &D, Standard_Real &E, Standard_Real &F) const
| Returns the normalized coefficients from the implicit equation of the circle : A * (X**2) + B * (Y**2) + 2*C*(X*Y) + 2*D*X + 2*E*Y + F = 0.0. More...
Standard_Boolean | Contains (const gp_Pnt2d &P, const Standard_Real LinearTolerance) const
| Does <me> contain P ? Returns True if the distance between P and any point on the circumference of the circle is lower of equal to <LinearTolerance>. More...
Standard_Real | Distance (const gp_Pnt2d &P) const
| Computes the minimum of distance between the point P and any point on the circumference of the circle. More...
Standard_Real | SquareDistance (const gp_Pnt2d &P) const
| Computes the square distance between <me> and the point P. More...
Standard_Real | Length () const
| computes the circumference of the circle. More...
const gp_Pnt2d & | Location () const
| Returns the location point (center) of the circle. More...
Standard_Real | Radius () const
| Returns the radius value of the circle. More...
const gp_Ax22d & | Axis () const
| returns the position of the circle. More...
const gp_Ax22d & | Position () const
| returns the position of the circle. Idem Axis(me). More...
gp_Ax2d | XAxis () const
| returns the X axis of the circle. More...
gp_Ax2d | YAxis () const
| Returns the Y axis of the circle. Reverses the direction of the circle. More...
void | Reverse ()
| Reverses the orientation of the local coordinate system of this circle (the "Y Direction" is reversed) and therefore changes the implicit orientation of this circle. Reverse assigns the result to this circle,. More...
gp_Circ2d | Reversed () const
| Reverses the orientation of the local coordinate system of this circle (the "Y Direction" is reversed) and therefore changes the implicit orientation of this circle. Reversed creates a new circle. More...
Standard_Boolean | IsDirect () const
| Returns true if the local coordinate system is direct and false in the other case. More...
void | Mirror (const gp_Pnt2d &P)
gp_Circ2d | Mirrored (const gp_Pnt2d &P) const
| Performs the symmetrical transformation of a circle with respect to the point P which is the center of the symmetry. More...
void | Mirror (const gp_Ax2d &A)
gp_Circ2d | Mirrored (const gp_Ax2d &A) const
| Performs the symmetrical transformation of a circle with respect to an axis placement which is the axis of the symmetry. More...
void | Rotate (const gp_Pnt2d &P, const Standard_Real Ang)
gp_Circ2d | Rotated (const gp_Pnt2d &P, const Standard_Real Ang) const
| Rotates a circle. P is the center of the rotation. Ang is the angular value of the rotation in radians. More...
void | Scale (const gp_Pnt2d &P, const Standard_Real S)
gp_Circ2d | Scaled (const gp_Pnt2d &P, const Standard_Real S) const
| Scales a circle. S is the scaling value. Warnings : If S is negative the radius stay positive but the "XAxis" and the "YAxis" are reversed as for an ellipse. More...
void | Transform (const gp_Trsf2d &T)
gp_Circ2d | Transformed (const gp_Trsf2d &T) const
| Transforms a circle with the transformation T from class Trsf2d. More...
void | Translate (const gp_Vec2d &V)
gp_Circ2d | Translated (const gp_Vec2d &V) const
| Translates a circle in the direction of the vector V. The magnitude of the translation is the vector's magnitude. More...
void | Translate (const gp_Pnt2d &P1, const gp_Pnt2d &P2)
gp_Circ2d | Translated (const gp_Pnt2d &P1, const gp_Pnt2d &P2) const
| Translates a circle from the point P1 to the point P2. More...
const gp_Ax22d & | _CSFDB_Getgp_Circ2dpos () const
Standard_Real | _CSFDB_Getgp_Circ2dradius () const
void | _CSFDB_Setgp_Circ2dradius (const Standard_Real p)

## Detailed Description

Describes a circle in the plane (2D space). A circle is defined by its radius and positioned in the plane with a coordinate system (a gp_Ax22d object) as follows:

- the origin of the coordinate system is the center of the circle, and
- the orientation (direct or indirect) of the coordinate system gives an implicit orientation to the circle (and defines its trigonometric sense). This positioning coordinate system is the "local coordinate system" of the circle. Note: when a gp_Circ2d circle is converted into a Geom2d_Circle circle, some implicit properties of the circle are used explicitly:
- the implicit orientation corresponds to the direction in which parameter values increase,
- the starting point for parameterization is that of the "X Axis" of the local coordinate system (i.e. the "X Axis" of the circle). See Also GccAna and Geom2dGcc packages which provide functions for constructing circles defined by geometric constraints gce_MakeCirc2d which provides functions for more complex circle constructions Geom2d_Circle which provides additional functions for constructing circles and works, with the parametric equations of circles in particular gp_Ax22d

## Constructor & Destructor Documentation

gp_Circ2d::gp_Circ2d | ( |  | ) |

creates an indefinite circle.

gp_Circ2d::gp_Circ2d | ( | const gp_Ax2d & | XAxis,
|  | const Standard_Real | Radius,
|  | const Standard_Boolean | Sense = `Standard_True`
| ) |  |

The location point of XAxis is the center of the circle. Warnings : It is not forbidden to create a circle with Radius = 0.0 Raises ConstructionError if Radius < 0.0. Raised if Radius < 0.0.

gp_Circ2d::gp_Circ2d | ( | const gp_Ax22d & | Axis,
|  | const Standard_Real | Radius
| ) |  |

Axis defines the Xaxis and Yaxis of the circle which defines the origin and the sense of parametrization. The location point of Axis is the center of the circle. Warnings : It is not forbidden to create a circle with Radius = 0.0 Raises ConstructionError if Radius < 0.0. Raised if Radius < 0.0.

## Member Function Documentation

const gp_Ax22d& gp_Circ2d::_CSFDB_Getgp_Circ2dpos | ( |  | ) | const
| inline

Standard_Real gp_Circ2d::_CSFDB_Getgp_Circ2dradius | ( |  | ) | const
| inline

void gp_Circ2d::_CSFDB_Setgp_Circ2dradius | ( | const Standard_Real | p | ) |
| inline

Standard_Real gp_Circ2d::Area | ( |  | ) | const

Computes the area of the circle.

const gp_Ax22d& gp_Circ2d::Axis | ( |  | ) | const

returns the position of the circle.

void gp_Circ2d::Coefficients | ( | Standard_Real & | A,
|  | Standard_Real & | B,
|  | Standard_Real & | C,
|  | Standard_Real & | D,
|  | Standard_Real & | E,
|  | Standard_Real & | F
| ) |  | const

Returns the normalized coefficients from the implicit equation of the circle : A * (X**2) + B * (Y**2) + 2*C*(X*Y) + 2*D*X + 2*E*Y + F = 0.0.

Standard_Boolean gp_Circ2d::Contains | ( | const gp_Pnt2d & | P,
|  | const Standard_Real | LinearTolerance
| ) |  | const

Does <me> contain P ? Returns True if the distance between P and any point on the circumference of the circle is lower of equal to <LinearTolerance>.

Standard_Real gp_Circ2d::Distance | ( | const gp_Pnt2d & | P | ) | const

Computes the minimum of distance between the point P and any point on the circumference of the circle.

Standard_Boolean gp_Circ2d::IsDirect | ( |  | ) | const

Returns true if the local coordinate system is direct and false in the other case.

Standard_Real gp_Circ2d::Length | ( |  | ) | const

computes the circumference of the circle.

const gp_Pnt2d& gp_Circ2d::Location | ( |  | ) | const

Returns the location point (center) of the circle.

void gp_Circ2d::Mirror | ( | const gp_Pnt2d & | P | ) |

void gp_Circ2d::Mirror | ( | const gp_Ax2d & | A | ) |

gp_Circ2d gp_Circ2d::Mirrored | ( | const gp_Pnt2d & | P | ) | const

Performs the symmetrical transformation of a circle with respect to the point P which is the center of the symmetry.

gp_Circ2d gp_Circ2d::Mirrored | ( | const gp_Ax2d & | A | ) | const

Performs the symmetrical transformation of a circle with respect to an axis placement which is the axis of the symmetry.

const gp_Ax22d& gp_Circ2d::Position | ( |  | ) | const

returns the position of the circle. Idem Axis(me).

Standard_Real gp_Circ2d::Radius | ( |  | ) | const

Returns the radius value of the circle.

void gp_Circ2d::Reverse | ( |  | ) |

Reverses the orientation of the local coordinate system of this circle (the "Y Direction" is reversed) and therefore changes the implicit orientation of this circle. Reverse assigns the result to this circle,.

gp_Circ2d gp_Circ2d::Reversed | ( |  | ) | const

Reverses the orientation of the local coordinate system of this circle (the "Y Direction" is reversed) and therefore changes the implicit orientation of this circle. Reversed creates a new circle.

void gp_Circ2d::Rotate | ( | const gp_Pnt2d & | P,
|  | const Standard_Real | Ang
| ) |  |

gp_Circ2d gp_Circ2d::Rotated | ( | const gp_Pnt2d & | P,
|  | const Standard_Real | Ang
| ) |  | const

Rotates a circle. P is the center of the rotation. Ang is the angular value of the rotation in radians.

void gp_Circ2d::Scale | ( | const gp_Pnt2d & | P,
|  | const Standard_Real | S
| ) |  |

gp_Circ2d gp_Circ2d::Scaled | ( | const gp_Pnt2d & | P,
|  | const Standard_Real | S
| ) |  | const

Scales a circle. S is the scaling value. Warnings : If S is negative the radius stay positive but the "XAxis" and the "YAxis" are reversed as for an ellipse.

void gp_Circ2d::SetAxis | ( | const gp_Ax22d & | A | ) |

Changes the X axis of the circle.

void gp_Circ2d::SetLocation | ( | const gp_Pnt2d & | P | ) |

Changes the location point (center) of the circle.

void gp_Circ2d::SetRadius | ( | const Standard_Real | Radius | ) |

Modifies the radius of this circle. This class does not prevent the creation of a circle where Radius is null. Exceptions Standard_ConstructionError if Radius is negative.

void gp_Circ2d::SetXAxis | ( | const gp_Ax2d & | A | ) |

Changes the X axis of the circle.

void gp_Circ2d::SetYAxis | ( | const gp_Ax2d & | A | ) |

Changes the Y axis of the circle.

Standard_Real gp_Circ2d::SquareDistance | ( | const gp_Pnt2d & | P | ) | const

Computes the square distance between <me> and the point P.

void gp_Circ2d::Transform | ( | const gp_Trsf2d & | T | ) |

gp_Circ2d gp_Circ2d::Transformed | ( | const gp_Trsf2d & | T | ) | const

Transforms a circle with the transformation T from class Trsf2d.

void gp_Circ2d::Translate | ( | const gp_Vec2d & | V | ) |

void gp_Circ2d::Translate | ( | const gp_Pnt2d & | P1,
|  | const gp_Pnt2d & | P2
| ) |  |

gp_Circ2d gp_Circ2d::Translated | ( | const gp_Vec2d & | V | ) | const

Translates a circle in the direction of the vector V. The magnitude of the translation is the vector's magnitude.

gp_Circ2d gp_Circ2d::Translated | ( | const gp_Pnt2d & | P1,
|  | const gp_Pnt2d & | P2
| ) |  | const

Translates a circle from the point P1 to the point P2.

gp_Ax2d gp_Circ2d::XAxis | ( |  | ) | const

returns the X axis of the circle.

gp_Ax2d gp_Circ2d::YAxis | ( |  | ) | const

Returns the Y axis of the circle. Reverses the direction of the circle.

The documentation for this class was generated from the following file:

- gp_Circ2d.hxx